package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZAPPEDITOR;
import cn.ibizlab.core.sample.filter.IBIZAPPEDITORSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZAPPEDITORMapper extends BaseMapper<IBIZAPPEDITOR> {


    Page<IBIZAPPEDITOR> searchDefault(IPage page, @Param("ctx") IBIZAPPEDITORSearchContext context, @Param("ew") Wrapper<IBIZAPPEDITOR> wrapper);
    List<IBIZAPPEDITOR> listDefault(@Param("ctx") IBIZAPPEDITORSearchContext context, @Param("ew") Wrapper<IBIZAPPEDITOR> wrapper);

    @Override
    IBIZAPPEDITOR selectById(Serializable id);

    IBIZAPPEDITOR selectEntity(IBIZAPPEDITOR entity);

    List<IBIZAPPEDITOR> selectEntities(@Param("list") List<IBIZAPPEDITOR> list);

    @Override
    int insert(IBIZAPPEDITOR entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZAPPEDITOR entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZAPPEDITOR entity, @Param("ew") Wrapper<IBIZAPPEDITOR> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZAPPEDITOR> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);


}